import type { FormContent } from "../FormContent";
import type { DeploymentTargetInputComponent } from "../InputComponents";
import type { InitialInputs } from "../InitialInputs";
import type { AvailableDeploymentTargetComponents } from "../AvailableComponents";
import type { ObjectInputPaths } from "@octopusdeploy/step-inputs";
import type { EmptyInitialInputFactories } from "../StepUI";

export interface DeploymentTargetUI<Inputs> {
    editInputsForm: EditDeploymentTargetInputsForm<Inputs>;
    createInitialInputs: (initialInputFactories: EmptyInitialInputFactories) => InitialInputs<Inputs>;
}

export type EditDeploymentTargetInputsForm<Inputs> = (
    inputPaths: ObjectInputPaths<Inputs>,
    availableComponents: AvailableDeploymentTargetComponents
) => FormContent<DeploymentTargetInputComponent>[];
